/*
 *+------------------------------------------------------------------------+
 *| Licensed Materials - Property of IBM                                   |
 *| (C) Copyright IBM Corp. 2003, 2004. All Rights Reserved.               |
 *|                                                                        |
 *| US Government Users Restricted Rights - Use, duplication or disclosure |
 *| restricted by GSA ADP Schedule Contract with IBM Corp.                 |
 *+------------------------------------------------------------------------+
 */
package com.ibm.jps.uctoanalysis.transformationProvider;
import com.ibm.xtools.transform.core.RootTransform;
import com.ibm.xtools.uml.transform.core.UMLKindTransform;
import com.ibm.xtools.transform.core.ITransformationDescriptor;
import org.eclipse.uml2.uml.UMLPackage;
import com.ibm.jps.uctoanalysis.transformation.rules.ModelRule;

/** 
 * @see com.ibm.xtools.transform.core.RootTransform
 */
public class UCToAnalysisTransformation extends RootTransform 
	{
	
	/**
	 * Constructor.
	 * @param descriptor  A transformation descriptor.
	 */
	public UCToAnalysisTransformation(ITransformationDescriptor descriptor) {
		super(descriptor);
		
		// Initialize root transform with main UML transform. 
		// The false argument indicates the main transform will only
		// accept individual source objects (and not the list of selected objects).
		UMLKindTransform umlkindTransform = new UMLKindTransform(descriptor);
		initialize(umlkindTransform, false);
		
		// Define the rules to be executed before and after the main UML transform.
		setupInitialize();
		setupFinalize();
		
		// Add the rules to the main UML transform.
		addUMLRules(umlkindTransform);
	}
	
	/**
	 * Add rules in this method that will be called once before the
	 * main UML transform is executed.
	 */
	private void setupInitialize () {
		//	TODO Auto-generated method
		// addToInit(transformElement);
	}
	/**
	 * Add rules in this method that will be called once after the
	 * main UML transform has been executed.
	 */
	private void setupFinalize () {
		//	TODO Auto-generated method
		// addToFinal(transformElement);
	}

	/**
	 * Add rules to the main UML transform where each rule is
	 * associated with a UML language element kind.
	 * 
	 * @param transform  The main UML transform.
	 * @generated
	 */
	private void addUMLRules(UMLKindTransform transform)
	{
		transform.addByKind(UMLPackage.eINSTANCE.getModel(), new ModelRule("com.ibm.jps.uctoanalysis.transformation.rule", "ModelRule"));
	
	}

}

